#include <stdio.h>

int  num_zadani;
char game_plan [150*300+6666]; 
int  width, height;
int  num_tahu;
int  tot_stonez;
int  score;
int i,j;

char *kamen ( int row, int col ) {
    if ( row > (height-1) || col > (width-1) || row < 0 || col < 0 ){
/*	printf("out\n");*/
	return &game_plan[width*height];
    }
    return &game_plan [ row*width+col ];
}

int test_pos ( int r, int c, char stone )
{
	if ( stone == *kamen ( r-1, c ) || stone == *kamen ( r+1,c ) ||
		stone == *kamen ( r, c+1 ) || stone == *kamen ( r, c - 1 ) ) 
	    return 1;
	return 0;
}
int hrej ( int r, int c, char stone )
{
	char* old;
	int num_stonez = 1;

    printf("%d %d : %c\n", r, c, stone);
	old = kamen(r,c);
	if ( stone != *old )
	    return 0;
	*old = 0;
	num_stonez = 1;

	num_stonez += hrej ( r-1,c,stone );
	num_stonez += hrej ( r+1,c,stone );
	num_stonez += hrej ( r,c-1,stone );
	num_stonez += hrej ( r,c+1,stone );

	return num_stonez;
}

void move_down ( int r, int c )
{
    int dr;
    char* stone;
    if ( r >= height - 1 )
	return;

    stone = kamen ( r,c );

    for ( dr = r + 1; dr < height - 1; dr++ )
    {
	if ( *kamen ( dr, c ) ) {
	    *kamen ( dr - 1, c ) = *stone;
	    *stone = 0;
	}
    }	
    if ( dr == height - 1 ) {
	*kamen ( height - 1, c ) = *stone;
	*stone = 0;
    }
}

void compact ( void )
{
	int r,c,cc;
	printf ( "%c %c\n", game_plan[0], game_plan[5] );

	for ( r = height-2; r >= 0; r-- )
	    for ( c = 0; c < width; c++ )
		if ( *kamen ( r,c ) ) 
		    move_down ( r,c );

	for ( cc = 0; cc < width; cc++ ) {
	    if ( !*kamen(height-1, cc)) {
		for ( c = cc+1; c < width; c++ ) {
		    if ( *kamen(height-1, c)) {
			for ( r = 0; r < height; r++ ) {
			    memmove ( kamen(r,cc),kamen(r,c), width-c-1 );
			    bzero ( kamen(r,width-(c-cc)), c - cc );
			}
			break;
		    }
		}
	    }
	}
	printf ( "%c %c\n", game_plan[3], game_plan[4] );
}

int main ( void )
{
    int r,c;
    int sc;

    scanf ( "%d", &num_zadani );

    while ( num_zadani-- ){
	scanf ( "%d %d", &width, &height );

	score = 0;
	tot_stonez = width * height;
	bzero ( game_plan, sizeof ( game_plan ) );

 	for ( r=0; r < height; r++ )
	    scanf ( "%s", &game_plan[width*r] );

	game_plan[20] = 0;
	printf ( "%s\n", game_plan );
	

	scanf ( "%d", &num_tahu );
	/*while ( num_tahu-- )*/
	{
	    scanf ( "%d %d", &r, &c );
	    r--;
	    c--;

/*	    printf ( "%d %d : %c\n", r, c, *kamen (r,c) );*/
	    if ( test_pos ( r,c, *kamen(r,c) ) )
		sc = hrej ( r,c, *kamen(r,c) );

	    printf ( "sc: %d\n", sc );
	    compact();

	    tot_stonez -= sc;
	    score += ( sc - 2 ) * ( sc - 2 );
	}

    }
    return 0;
}
